import model.Node;
import model.Tree;

/**
 * Created by user on 29.04.2017.
 */
public class TreeWorkerImpl implements TreeWorker {

    @Override
    public void prettyPrint(Tree<?> tree) {
        if (tree instanceof Tree)
            TreePrinter.printNode((Node) tree);
    }

    @Override
    public <T> Tree<T> clone(Tree<T> tree) {
        if (tree == null || !(tree instanceof Node))
            return null;
        Node root = new Node<>();
        Node tmp = (Node) tree;
        root.left = clone(tmp.left);
        root.right = clone(tmp.right);
        root.value = tmp.value;
        return root;
    }

    @Override
    public <T> Tree<T> generate(int depth, T value) {
        Node root = new Node<>();
        if (depth > 1) {
            root.left = generate(depth - 1, value);
            root.right = generate(depth - 1, value);
            root.value = value;
        } else {
            root.value = value;
        }
        return root;
    }
}
